#include <MAX30100.h>

#include <CircularBuffer.h>
#include <MAX30100.h>
#include <MAX30100_BeatDetector.h>
#include <MAX30100_Filters.h>
#include <MAX30100_PulseOximeter.h>
#include <MAX30100_Registers.h>
#include <MAX30100_SpO2Calculator.h>

#include <Adafruit_GFX.h>        //OLED  libraries
#include <Adafruit_SSD1306.h>
#include <Wire.h>
#include "MAX30100.h"           //MAX3010x library
#include "heartRate.h"          //Heart rate  calculating algorithm

#include <MAX30100.h>

#include <Wire.h>
#include "MAX30100_PulseOximeter.h"

 
#define REPORTING_PERIOD_MS     1000

#define SCREEN_WIDTH  128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display  height, in pixels
#define OLED_RESET    -1 // Reset pin # (or -1 if sharing Arduino  reset pin)
 
#define MY_LED 13

Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);  //Declaring the display name (display)
PulseOximeter pox;
uint32_t tsLastReport = 0;
 
int buttonState1=0;
int buttonState2=0;
int lastButton1Press = 0;
int lastButton2Press = 0;
int debounceInterval = 400;

#define STEP 500
unsigned int interval = 1000;



const int buttonPin1=4;
const int buttonPin2=2;

void onBeatDetected()
{
    Serial.println("Beat!");
}
 
void setup()
{
  pinMode(MY_LED,OUTPUT);
pinMode(buttonPin1,INPUT_PULLUP);
pinMode(buttonPin2,INPUT_PULLUP);

  display.begin(SSD1306_SWITCHCAPVCC,  0x3C); //Start the OLED display
  display.display();
  delay(3000);
    Serial.begin(115200);
    Serial.print("Initializing pulse oximeter..");
 
    // Initialize the PulseOximeter instance
    // Failures are generally due to an improper I2C wiring, missing power supply
    // or wrong target chip
    if (!pox.begin()) {
        Serial.println("FAILED");
        for(;;);
    } else {
        Serial.println("SUCCESS");
    }
     pox.setIRLedCurrent(MAX30100_LED_CURR_7_6MA);
 
    // Register a callback for the beat detection
    pox.setOnBeatDetectedCallback(onBeatDetected);
}
 
void loop()
{
  buttonState1 = digitalRead(buttonPin1);
  buttonState2 = digitalRead(buttonPin2);

  if(buttonState1 == 0){
    if(lastButton1Press + debounceInterval < millis()){
      lastButton1Press = millis();
      interval -= STEP;

    }
  }
  if(buttonState2 == 0){  
    if(lastButton2Press + debounceInterval < millis()){
      lastButton2Press = millis();
      interval += STEP;
    }
  }

/*
Configurat timer care genereaza intreruperi la "interval", trebuie modificat dupa fiecare actualizarea a valorii.
In ISR doar faci toggle pe pinul LED-ului.
*/
    pox.update();
    if (millis() - tsLastReport > REPORTING_PERIOD_MS) {
        Serial.print("Heart rate:");
        Serial.print(pox.getHeartRate());
        Serial.print("bpm / SpO2:");
        Serial.print(pox.getSpO2());
        Serial.println("%");

        display.clearDisplay();                                   //Clear the display
    display.setTextSize(2);                                   //Near  it display the average BPM you can display the BPM if you want
    display.setTextColor(WHITE);  
    display.setCursor(0,0);                
    display.println("BPM");             
    display.setCursor(0,18);                
    display.println(truncf(pox.getHeartRate()));  
    // display.display();


    display.setCursor(80,0);                
    display.println("SpO2");             
    display.setCursor(80,18);                
    display.println(pox.getSpO2());  
    display.display();

    // delay(1000); 
    tone(3,1000, 100); //And  tone the buzzer for a 100ms you can reduce it it will be better
    // delay(100);
    delay(100);
    noTone(3); 
    digitalWrite(3, HIGH);
 
        tsLastReport = millis();
    }
}